unit mTTeil;

interface
uses
  Graphics,    // 
  Math;        // fr arccos
  
type
  TPunkt = record
             x,y : real;
           end;

  TPArray = array of TPunkt;

  TTeil = class(TObject)
  private
    FP     : TPArray;
    FFarbe : TColor;
  public
    name : string; // DEBUG
    procedure setP(P : TPArray);
    function getP : TPArray;
    procedure setFarbe(farbe : TColor);
    function getFarbe : TColor;
    procedure schiebe(dx,dy : real);
    procedure drehe(alpha : real);
    procedure spiegele;
  end;

implementation

procedure TTeil.setP(P : TPArray);
begin
  SetLength(FP,0); // sicherheitshalber Speicher freigeben
  FP := Copy(P);   // Kopie speichern
end;

function TTeil.getP : TPArray;
begin
  result := FP;
end;

procedure TTeil.setFarbe(farbe : TColor);
begin
  FFarbe := farbe;
end;

function TTeil.getFarbe : TColor;
begin
  result := FFarbe;
end;

procedure TTeil.schiebe(dx,dy : real);
var
  i,n : integer;
begin
  n := Length(FP);
  for i := 0 to n-1 do
  begin
    FP[i].x := FP[i].x + dx;
    FP[i].y := FP[i].y + dy;
  end;
end;

  function Schwerpunkt(P : TPArray) : TPunkt;
  var
    i,n   : integer;
    sx,sy : real;
  begin
    n := Length(P);
    sx := 0; sy := 0;
    for i := 0 to n-1 do
    begin
      sx := sx + P[i].x; sy := sy + P[i].y;
    end;
    result.x := sx/n;
    result.y := sy/n;
  end;

  function gedreht(P,D : TPunkt; alpha : real) : TPunkt;
  begin
    result.x := cos(alpha)*(P.x-D.x) - sin(alpha)*(P.y-D.y) + D.x;
    result.y := sin(alpha)*(P.x-D.x) + cos(alpha)*(P.y-D.y) + D.y;
  end;

procedure TTeil.drehe(alpha : real);
var
  i,n : integer;
  D   : TPunkt;
begin
  n := Length(FP);
  D := Schwerpunkt(FP);
  for i := 0 to n-1 do FP[i] := gedreht(FP[i],D,alpha);
end;

procedure TTeil.spiegele;
var
  i,n,j : integer;
  S,H   : TPunkt;
begin
  n := Length(FP);
  S := Schwerpunkt(FP);
  for i := 0 to n-1 do FP[i].x := -FP[i].x + 2*S.x; // Achtung: ndert Umlaufsinn
  i := 0; j := n-1;                                 // deshalb Reihenfolge ndern
  while i < j do
  begin
    H := FP[i]; FP[i] := FP[j]; FP[j] := H;
    Inc(i); Dec(j);
  end;
end;


end.
