unit uEvolution1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, mTTeil, mTWeltBildManager;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    wbm  : TWeltBildManager;
    Teil : TTeil;
    procedure zeichneTeil;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  P : TPArray;
begin
  wbm  := TWeltBildManager.Create;
  wbm.berechneKoeffizienten(-2,6,-1,5,8*50,6*50);
  Teil := TTeil.Create;
  SetLength(P,3);
  P[0].x := 0; P[0].y := 0;
  P[1].x := 2; P[1].y := 0;
  P[2].x := 0; P[2].y := 3;
  Teil.setP(P);
  SetLength(P,0);
  Teil.setFarbe(clRed);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  wbm.Free;
  Teil.Free;
end;

procedure TForm1.zeichneTeil;
var
  BP    : array of TPoint;         // Bild-Polygon
  i,n   : integer;
  farbe : TColor;
begin
  n := Length(Teil.getP);
  SetLength(BP,n);                 // Speicher reservieren
  for i := 0 to n-1 do             // Bild-Polygon mit transformierten Werten fllen
  begin
    BP[i].X := wbm.ut(Teil.GetP[i].x);
    BP[i].Y := wbm.vt(Teil.GetP[i].y);
  end;
  with canvas do
  begin
    fillrect(rect(0,0,8*50,6*50)); // lschen
    farbe := Brush.Color;          // Hintergrundfarbe merken
    Brush.Color := Teil.getFarbe;  // Fll-Farbe setzen
    Polygon(BP);
    Brush.Color := farbe;          // Hintergrundfarbe restaurieren
  end;
  SetLength(BP,0);                 // Speicher freigeben
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  zeichneTeil;
end;

end.
